#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<int> > g;
set<int> result;
vector<pair<int, int> > security;

void BFS(int start, int h) {
    queue<pair<int, int> > q;
    vector<bool> visited(g.size());

    if (h >= 0) {
        q.emplace(start, h);
        visited[start] = true;
        result.insert(start);
    }

    while (!q.empty()) {
        int currV = q.front().first;
        int remainingStamina = q.front().second;
        q.pop();

        if (remainingStamina > 0) {
            for (int neighbor: g[currV]) {
                if (!visited[neighbor]) {
                    visited[neighbor] = true;
                    q.emplace(neighbor, remainingStamina - 1);
                    result.insert(neighbor);
                }
            }
        }
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1);
    security.resize(k);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < k; i++) {
        cin >> security[i].first >> security[i].second;
    }
    for (const auto &guard: security) {
        BFS(guard.first, guard.second);
    }
    cout << result.size() << '\n';
    for (auto x: result) {
        cout << x << " ";
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int t = 1;
    // cin >> t;
    solve();
}
