#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<int> > g;
vector<pair<int, int> > security;
vector<int> stamina;
priority_queue<pair<int, int> > pq;

void BFS() {
    while (!pq.empty()) {
        int remainingStamina = pq.top().first;
        int currV = pq.top().second;
        pq.pop();

        if (remainingStamina > 0) {
            for (int neighbor: g[currV]) {
                if (remainingStamina - 1 > stamina[neighbor]) {
                    stamina[neighbor] = remainingStamina - 1;
                    pq.emplace(remainingStamina - 1, neighbor);
                }
            }
        }
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1);
    stamina.assign(n + 1, -1);
    security.resize(k);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < k; i++) {
        int num, stamin;
        cin >> num >> stamin;
        stamina[num] = stamin;
        pq.emplace(stamin,  num);
    }
    BFS();
    vector<int> result;
    for (int i = 0; i <= n; i++) {
        if (stamina[i] != -1) {
            result.push_back(i);
        }
    }
    cout << result.size() << '\n';
    for (auto x: result) {
        cout << x << ' ';
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int t = 1;
    // cin >> t;
    solve();
}
